[CareerCup] 9.2 Robot Moving 机器人移动 - Grandyang - 博客园
9.2 Imagine a robot sitting on the upper left corner of an X by Y grid. The robot can only move in two directions: right and down. How many possible paths are there for the robot to go from (0,0) to (X,Y)?
FOLLOW UP
Imagine certain spots are "off limits," such that the robot cannot step on them. Design an algorithm to find a path for the robot from the top left to the bottom right.
http://www.smallqiao.com/74046.html
这道题的Follow up说格子中可能有障碍物,即不能到达的位子,让我们找到一条从左上点到右下点的路径,只需一条而已,不用将所有的都找出来,那么我们使用递归来做,我们反方向走,从右下点往左上点找,我们用哈希表来记录某个位置是否访问过,当递归到原点的时候,我们把原点加入结果中,然后逐层递归返回,把路径中的点依次加入结果中,这样结果中保存的顺序就是正确的
public static ArrayList<Point> findPath(int[][] map) {
ArrayList<Point> path = new ArrayList<Point>();
findPath(map.length - 1, map[0].length - 1, map, path);
return path;
}
private static boolean findPath(int x, int y, int[][] map, ArrayList<Point> path) {
if (x < 0 || y < 0) return false;
if (map[x][y] == 0) return false;
Point p = new Point(x, y);
if (x == 0 && y == 0) {
path.add(p);
return true;
}
boolean success = findPath(x - 1, y, map, path);
if (!success) success = findPath(x, y - 1, map, path);
if (success) path.add(p);
return success;
}
public static ArrayList<Point> findPathDP(int[][] map) {
ArrayList<Point> path = new ArrayList<Point>();
HashMap<Point, Boolean> cache = new HashMap<Point, Boolean>();
findPathDP(map.length - 1, map[0].length - 1, map, path, cache);
return path;
}
private static boolean findPathDP(int x, int y, int[][] map, ArrayList<Point> path, HashMap<Point, Boolean> cache) {
if (x < 0 || y < 0) return false;
if (map[x][y] == 0) return false;
Point p = new Point(x, y);
if (cache.containsKey(p)) return cache.get(p);
if (x == 0 && y == 0) {
path.add(p);
return true;
}
boolean success = findPathDP(x - 1, y, map, path, cache);
if (!success) success = findPathDP(x, y - 1, map, path, cache);
if (success) path.add(p);
cache.put(p, success);
return success;
}
/**
* FOLLOW UP
* Find all paths.
*/
public static ArrayList<ArrayList<Point>> findAllPaths(int[][] map) {
ArrayList<ArrayList<Point>> result = new ArrayList<ArrayList<Point>>();
findAllPaths(map.length - 1, map[0].length - 1, map, new ArrayList<Point>(), result);
return result;
}
// pass in an ArrayList as buffer
@SuppressWarnings("unchecked")
private static void findAllPaths(int x, int y, int[][] map,
ArrayList<Point> path, ArrayList<ArrayList<Point>> result) {
if (x < 0 || y < 0) return;
if (map[x][y] == 0) return;
Point p = new Point(x, y);
path.add(0, p);
if (x == 0 && y == 0) {
result.add((ArrayList<Point>) path.clone());
}
findAllPaths(x - 1, y, map, path, result);
findAllPaths(x, y - 1, map, path, result);
path.remove(p);
}
public static ArrayList<ArrayList<Point>> findAllPaths2(int[][] map) {
ArrayList<ArrayList<Point>> result = new ArrayList<ArrayList<Point>>();
Point[] path = new Point[2 * map.length - 1];
findAllPaths2(map.length - 1, map[0].length - 1, map, path, path.length - 1, result);
return result;
}
// pass in an Array as buffer
private static void findAllPaths2(int x, int y, int[][] map,
Point[] path, int index, ArrayList<ArrayList<Point>> result) {
if (x < 0 || y < 0) return;
if (map[x][y] == 0) return;
Point p = new Point(x, y);
path[index] = p;
if (x == 0 && y == 0) {
result.add(new ArrayList<Point>(Arrays.asList(path)));
}
findAllPaths2(x - 1, y, map, path, index - 1, result);
findAllPaths2(x, y - 1, map, path, index - 1, result);
}
https://gist.github.com/WOLOHAHA/9264c6d6df7bc9afb561
public int uniquePathsFollowup(int[][] obstacleGrid) {
int m=obstacleGrid.length;
int n=obstacleGrid[0].length;
if(m==0||n==0)
return 0;
if(obstacleGrid[0][0]==1)
return 0;
int[][] result=new int[m][n];
for(int i=0;i<m;i++){
for(int j=0;j<n;j++){
if(obstacleGrid[i][j]==0){
if(i==0&&j==0)
result[i][j]=1;
else
result[i][j]=((i>0)?result[i-1][j]:0)+((j>0)?result[i][j-1]:0);
}else{
result[i][j]=0;
}
}
}
return result[m-1][n-1];
}
Robot in a Grid
: Imagine a robot sitting on the upper left corner of grid with r rows and c columns.
The robot can only move in two directions, right and down, but certain cells are "off limits" such that
the robot cannot step on them. Design an algorithm to find a path for the robot from the top left to
the bottom right.
make your life easier by using r (row) and c (column) instead.
This solution is O ( 2r+c ), since each path has r+c steps and there are two choices we can make at each step.
Arraylist<Point> getPath(boolean[][] maze) {
if (maze == null I I maze.length == 0) return null;
ArrayList<Point> path = new Arraylist<Point>();
if (getPath(maze, maze.length - 1, maze[0].length - 1, path)) {
return path;
}
return null;
}
boolean getPath(boolean[][] maze, int row, int col, Arraylist<Point> path) {
/* If out of bounds or not available, return.*/
if (col < 0 11 row < 0 11 !maze[row][col]) {
return false;
}
boolean isAtOrigin =(row == 0) && (col == 0);
/* If there's a path from the start to here, add my location. */
if (isAtOrigin I I getPath(maze, row, col - 1, path) I I
getPath(maze, row - 1, col, path)) {
Point p = new Point(row, col);
path.add(p);
return true;
}
return false;
}
Arraylist<Point> getPath(boolean[][] maze) {
if (maze == null I I maze.length == 0) return null;
Arraylist<Point> path= new Arraylist<Point>();
HashSet<Point> failedPoints = new HashSet<Point>();
if (getPath(maze, maze.length - 1, maze[0].length - 1, path, failedPoints)) {
return path;
}
return null;
}
boolean getPath(boolean[][] maze, int row, int col, Arraylist<Point> path,
HashSet<Point> failedPoints) {
/* If out of bounds or not available, return.*/
if (col < 0 11 row < 0 11 !maze[row][col]) {
return false;
}
Point p = new Point(row, col);
/* If we've already visited this cell, return. */
if (failedPoints.contains(p)) {
return false;
}
boolean isAtOrigin =(row== 0) && (col== 0);
/* If there's a path from start to my current loc ation, add my location.*/
if (isAtOrigin I I getPath(maze, row, col - 1, path, failedPoints) I I
getPath(maze, row - 1, col, path, failedPoints)) {
path.add(p);
return true;
}
failedPoints.add(p); // Cache result
return false;
}
Read full article from [CareerCup] 9.2 Robot Moving 机器人移动 - Grandyang - 博客园
9.2 Imagine a robot sitting on the upper left corner of an X by Y grid. The robot can only move in two directions: right and down. How many possible paths are there for the robot to go from (0,0) to (X,Y)?
FOLLOW UP
Imagine certain spots are "off limits," such that the robot cannot step on them. Design an algorithm to find a path for the robot from the top left to the bottom right.
http://www.smallqiao.com/74046.html
LeetCode上的原题,请参见我之前的博客Unique Paths 不同的路径和Unique Paths II 不同的路径之二。
int getPath(int x, int y) { vector<int> dp(y + 1, 1); for (int i = 1; i <= x; ++i) { for (int j = 1; j <= y; ++j) { dp[j] += dp[j - 1]; } } return dp[y]; }
int getPath(int x, int y) { double num = 1, denom = 1; int small = x < y ? x : y; for (int i = 1; i <= small; ++i) { num *= x + y - i + 1; denom *= i; } return (int)(num / denom); }https://github.com/honghaoz/CrackingTheCodingInterview/blob/master/Chapter%209_Recursion%20and%20Dynamic%20Programming/9.2.py
这道题的Follow up说格子中可能有障碍物,即不能到达的位子,让我们找到一条从左上点到右下点的路径,只需一条而已,不用将所有的都找出来,那么我们使用递归来做,我们反方向走,从右下点往左上点找,我们用哈希表来记录某个位置是否访问过,当递归到原点的时候,我们把原点加入结果中,然后逐层递归返回,把路径中的点依次加入结果中,这样结果中保存的顺序就是正确的
vector<Point*> getPath(vector<vector<int> > &grid, int x, int y) { vector<Point*> res; unordered_map<Point*, bool> m; getPathDFS(grid, x, y, m, res); return res; } bool getPathDFS(vector<vector<int> > &grid, int x, int y, unordered_map<Point*, bool> &m, vector<Point*> &res) { if (x < 0 || y < 0 || grid[x][y] == 1) return false; Point *p = new Point(x, y); if (m.find(p) != m.end()) return m[p]; bool isAtOrigin = (x == 0) && (y == 0), success = false; if (isAtOrigin || getPathDFS(grid, x, y - 1, m, res) || getPathDFS(grid, x - 1, y, m, res)) { res.push_back(p); success = true; } m[p] = success; return success; }https://github.com/wzhishen/cracking-the-coding-interview/blob/master/src/chap09/Q02.java
public static ArrayList<Point> findPath(int[][] map) {
ArrayList<Point> path = new ArrayList<Point>();
findPath(map.length - 1, map[0].length - 1, map, path);
return path;
}
private static boolean findPath(int x, int y, int[][] map, ArrayList<Point> path) {
if (x < 0 || y < 0) return false;
if (map[x][y] == 0) return false;
Point p = new Point(x, y);
if (x == 0 && y == 0) {
path.add(p);
return true;
}
boolean success = findPath(x - 1, y, map, path);
if (!success) success = findPath(x, y - 1, map, path);
if (success) path.add(p);
return success;
}
public static ArrayList<Point> findPathDP(int[][] map) {
ArrayList<Point> path = new ArrayList<Point>();
HashMap<Point, Boolean> cache = new HashMap<Point, Boolean>();
findPathDP(map.length - 1, map[0].length - 1, map, path, cache);
return path;
}
private static boolean findPathDP(int x, int y, int[][] map, ArrayList<Point> path, HashMap<Point, Boolean> cache) {
if (x < 0 || y < 0) return false;
if (map[x][y] == 0) return false;
Point p = new Point(x, y);
if (cache.containsKey(p)) return cache.get(p);
if (x == 0 && y == 0) {
path.add(p);
return true;
}
boolean success = findPathDP(x - 1, y, map, path, cache);
if (!success) success = findPathDP(x, y - 1, map, path, cache);
if (success) path.add(p);
cache.put(p, success);
return success;
}
/**
* FOLLOW UP
* Find all paths.
*/
public static ArrayList<ArrayList<Point>> findAllPaths(int[][] map) {
ArrayList<ArrayList<Point>> result = new ArrayList<ArrayList<Point>>();
findAllPaths(map.length - 1, map[0].length - 1, map, new ArrayList<Point>(), result);
return result;
}
// pass in an ArrayList as buffer
@SuppressWarnings("unchecked")
private static void findAllPaths(int x, int y, int[][] map,
ArrayList<Point> path, ArrayList<ArrayList<Point>> result) {
if (x < 0 || y < 0) return;
if (map[x][y] == 0) return;
Point p = new Point(x, y);
path.add(0, p);
if (x == 0 && y == 0) {
result.add((ArrayList<Point>) path.clone());
}
findAllPaths(x - 1, y, map, path, result);
findAllPaths(x, y - 1, map, path, result);
path.remove(p);
}
public static ArrayList<ArrayList<Point>> findAllPaths2(int[][] map) {
ArrayList<ArrayList<Point>> result = new ArrayList<ArrayList<Point>>();
Point[] path = new Point[2 * map.length - 1];
findAllPaths2(map.length - 1, map[0].length - 1, map, path, path.length - 1, result);
return result;
}
// pass in an Array as buffer
private static void findAllPaths2(int x, int y, int[][] map,
Point[] path, int index, ArrayList<ArrayList<Point>> result) {
if (x < 0 || y < 0) return;
if (map[x][y] == 0) return;
Point p = new Point(x, y);
path[index] = p;
if (x == 0 && y == 0) {
result.add(new ArrayList<Point>(Arrays.asList(path)));
}
findAllPaths2(x - 1, y, map, path, index - 1, result);
findAllPaths2(x, y - 1, map, path, index - 1, result);
}
https://gist.github.com/WOLOHAHA/9264c6d6df7bc9afb561
public int uniquePathsFollowup(int[][] obstacleGrid) {
int m=obstacleGrid.length;
int n=obstacleGrid[0].length;
if(m==0||n==0)
return 0;
if(obstacleGrid[0][0]==1)
return 0;
int[][] result=new int[m][n];
for(int i=0;i<m;i++){
for(int j=0;j<n;j++){
if(obstacleGrid[i][j]==0){
if(i==0&&j==0)
result[i][j]=1;
else
result[i][j]=((i>0)?result[i-1][j]:0)+((j>0)?result[i][j-1]:0);
}else{
result[i][j]=0;
}
}
}
return result[m-1][n-1];
}
Robot in a Grid
: Imagine a robot sitting on the upper left corner of grid with r rows and c columns.
The robot can only move in two directions, right and down, but certain cells are "off limits" such that
the robot cannot step on them. Design an algorithm to find a path for the robot from the top left to
the bottom right.
make your life easier by using r (row) and c (column) instead.
This solution is O ( 2r+c ), since each path has r+c steps and there are two choices we can make at each step.
Arraylist<Point> getPath(boolean[][] maze) {
if (maze == null I I maze.length == 0) return null;
ArrayList<Point> path = new Arraylist<Point>();
if (getPath(maze, maze.length - 1, maze[0].length - 1, path)) {
return path;
}
return null;
}
boolean getPath(boolean[][] maze, int row, int col, Arraylist<Point> path) {
/* If out of bounds or not available, return.*/
if (col < 0 11 row < 0 11 !maze[row][col]) {
return false;
}
boolean isAtOrigin =(row == 0) && (col == 0);
/* If there's a path from the start to here, add my location. */
if (isAtOrigin I I getPath(maze, row, col - 1, path) I I
getPath(maze, row - 1, col, path)) {
Point p = new Point(row, col);
path.add(p);
return true;
}
return false;
}
The algorithm will now take O(XY) time because we hit each cell just once.
Arraylist<Point> getPath(boolean[][] maze) {
if (maze == null I I maze.length == 0) return null;
Arraylist<Point> path= new Arraylist<Point>();
HashSet<Point> failedPoints = new HashSet<Point>();
if (getPath(maze, maze.length - 1, maze[0].length - 1, path, failedPoints)) {
return path;
}
return null;
}
boolean getPath(boolean[][] maze, int row, int col, Arraylist<Point> path,
HashSet<Point> failedPoints) {
/* If out of bounds or not available, return.*/
if (col < 0 11 row < 0 11 !maze[row][col]) {
return false;
}
Point p = new Point(row, col);
/* If we've already visited this cell, return. */
if (failedPoints.contains(p)) {
return false;
}
boolean isAtOrigin =(row== 0) && (col== 0);
/* If there's a path from start to my current loc ation, add my location.*/
if (isAtOrigin I I getPath(maze, row, col - 1, path, failedPoints) I I
getPath(maze, row - 1, col, path, failedPoints)) {
path.add(p);
return true;
}
failedPoints.add(p); // Cache result
return false;
}
Read full article from [CareerCup] 9.2 Robot Moving 机器人移动 - Grandyang - 博客园